@ECHO OFF


:PERMISSIONCHK
   ATTRIB %windir%\system32 -h | FINDSTR /I "denied" >nul
   IF NOT ERRORLEVEL 1 (
   ECHO.
   ECHO run as administrator
   ECHO.
   PAUSE
   EXIT )

:PRODUCTVERCHK
   FOR /F "tokens=*" %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "ProductName"') DO SET VERSION=%%A
   ECHO %VERSION% | FINDSTR /I "ULTIMATE" >nul
	IF NOT ERRORLEVEL 1 GOTO SERVICEPACK
   ECHO %VERSION% | FINDSTR /I "BUSINESS" >nul
	IF NOT ERRORLEVEL 1 GOTO SERVICEPACK
   ECHO %VERSION% | FINDSTR /I "PREMIUM" >nul
	IF NOT ERRORLEVEL 1 SET PID=PREMIUM& GOTO SERVICEPACK
   GOTO UNSUPPORTED

:SERVICEPACK
	REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" | FINDSTR /I "CSDVersion" >nul
		IF ERRORLEVEL 1 SET SP=No Service Pack& GOTO UNSUPPORTED
	FOR /F "tokens=*" %%A IN ('REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "CSDVersion"') DO SET SP=%%A
	ECHO %SP% | FINDSTR /I "SERVICE^ PACK^ 1" >nul
		IF NOT ERRORLEVEL 1 GOTO START
	ECHO %SP% | FINDSTR /I "SERVICE^ PACK^ 2" >nul
		IF NOT ERRORLEVEL 1 GOTO UNSUPPORTED
	ECHO %SP% | FINDSTR /I "SERVICE^ PACK^ 3" >nul
		IF NOT ERRORLEVEL 1 GOTO UNSUPPORTED
GOTO UNSUPPORTED

:UNSUPPORTED
   ECHO.
   ECHO your operating system is not supported
   ECHO.
   ECHO Only for Vista Ultimate, Business, Premuim 
   ECHO Service Pack 1 
   ECHO.  
   PAUSE
   EXIT

:START
   CLS
   IF /I EXIST %systemroot%\SysWOW64 SET BIT=Y

:DETECTARGUMENTS
   SET SINGLESESSION=0
   SET BLANK=0
   IF /I *%1 == *MULTI SET SINGLESESSION=0
   IF /I *%2 == *MULTI SET SINGLESESSION=0
   IF /I *%1 == *BLANK SET BLANK=0
   IF /I *%2 == *BLANK SET BLANK=0

:SETSOURCEFOLDER
   REM This will get the folder the batch file was launched from since the current
   REM directory will change if launched from a NETwork share
   SET SOURCEFOLDER=%~dp0
   ECHO Source Folder is %SOURCEFOLDER%
   ECHO.

:TAKEOWNERSHIP
   ECHO Taking ownership of %SystemRoot%\System32\termsrv.dll
   takeown /a /f %SystemRoot%\System32\termsrv.dll
   ECHO Granting Administrators rights
   ICACLS %SystemRoot%\System32\termsrv.dll /Grant Administrators:F

:STOPTERMINALSERVICES
   ECHO Stopping Terminal Services
   NET stop "Terminal Services"

:BACKUPTERMSRVDLL
   COPY "%SystemRoot%\System32\termsrv.dll" "%SystemRoot%\System32\*.*.bak"

:COPYTERMSRVDLL

   IF '%BIT%'=='Y' (
   ECHO Copying "%SOURCEFOLDER%64_termsrv.dll" to "%SystemRoot%\System32\termsrv.dll"
   ) ELSE (ECHO Copying "%SOURCEFOLDER%32_termsrv.dll" to "%SystemRoot%\System32\termsrv.dll") 

   IF '%BIT%'=='Y' (
   COPY /Y "%SOURCEFOLDER%64_termsrv.dll" "%SystemRoot%\System32\termsrv.dll"
   ) ELSE (COPY /Y "%SOURCEFOLDER%32_termsrv.dll" "%SystemRoot%\System32\termsrv.dll")

 IF '%PID%'=='PREMIUM' (
   ECHO Copying Vista Premium Edition specific files
   IF '%BIT%'=='Y' (
   ECHO Copying "%SOURCEFOLDER%64_rdpclip.exe" to "%SystemRoot%\System32\rdpclip.exe"
   ) ELSE (ECHO Copying "%SOURCEFOLDER%32_rdpclip.exe" to "%SystemRoot%\System32\rdpclip.exe")
   IF '%BIT%'=='Y' (
   COPY /y "%SOURCEFOLDER%64_rdpclip.exe" "%SystemRoot%\System32\rdpclip.exe"
   ) ELSE (COPY /y "%SOURCEFOLDER%32_rdpclip.exe" "%SystemRoot%\System32\rdpclip.exe")
 )

:IMPORTREGKEYS
   IF '%PID%'=='PREMIUM' (
   ECHO Importing Vista Premium Edition specific registry keys
   REGEDIT /S "%SOURCEFOLDER%termonpremium.reg"
   )
   ECHO Enabling RDP
   REG ADD "HKLM\SYSTEM\CurrentControlSet\Control\Terminal Server" /v fDenyTSConnections /t REG_DWORD /d 0 /f

:SETSINGLESESSIONSETTING
   ECHO Setting fSingleSessionPerUser to %SINGLESESSION%
   REG ADD "HKLM\SYSTEM\CurrentControlSet\Control\Terminal Server" /v fSingleSessionPerUser /t REG_DWORD /d %SINGLESESSION% /f

:SETBLANKPASSWORDPOLICY
   ECHO Setting LimitBlankPasswordUser to %BLANK%
   REG ADD "HKLM\SYSTEM\CurrentControlSet\Control\Lsa" /v LimitBlankPasswordUse /t REG_DWORD /d %BLANK% /f
   
:CONFIGUREFIREWALL
   ECHO Configuring Remote Desktop in Windows Firewall
   NETSH firewall set service remotedesktop enable
   IF '%PID%'=='PREMIUM' (
   ECHO Creating firewall rules for Vista Premium Edition
   NETSH advfirewall firewall add rule name="remotedesktop" dir=in action=allow protocol=6 LocalPort=3389 Program=System
   NETSH firewall set service remotedesktop enable
   )

:STARTTERMINALSERVICES
   ECHO Starting Terminal Services
   NET START "Terminal Services"

:PAUSE5SECONDS
   ECHO Pausing 5 seconds to give service time to start listening
   CHOICE /n /c y /d y /t 5 > nul

:CHECKIFSERVICELISTENING
   ECHO Checking if Service is listening on port 3389
   SUBST
   NETSTAT -a | find /i "3389"
   IF ERRORLEVEL 1 GOTO SERVICENOTLISTENING

:SERVICEISLISTENING
   ECHO Service is listening
   GOTO CONTINUE

:SERVICENOTLISTENING
   ECHO Service is not listening

:CONTINUE
   ECHO Done
   PAUSE